{-----------------}
{arifmetika kompleksn. `isel tlq TMT-paskalq}

 type complex=record re,im:double; end;

 const i_:complex=(re:0; im:1);

 function wy(c:complex):string; var s1,s2:string[20];
 begin str(c.re:5:2,s1); str(c.im:5:2,s2); wy:=' ('+s1+' '+s2+')'; end;

 function soprqz(a:complex):complex;
 begin result.re:=a.re; result.im:=-a.im; end;

 function csqrt(b:complex):complex; var r,i,rr,fi,tgfi:double;
 begin
  r:=b.re; i:=b.im; rr:=sqrt(sqr(r)+sqr(i));
  if (r=0) and (i=0) then fi:=0; {uslovno}
  if (r=0) and (i>0) then fi:=pi/2;
  if (r=0) and (i<0) then fi:=3*pi/2;
  if (r<>0) then begin
   tgfi:=i/r; fi:=arctan(tgfi);
   if r<0 then fi:=fi+pi; if (i<0) and (r>0) then fi:=fi+2*pi;
  end; {eto obyesp.fi=0..2*pi};
  rr:=sqrt(rr); fi:=fi/2; r:=rr*cos(fi); i:=rr*sin(fi);
  if i<0 then begin r:=-r; i:=-i end; result.re:=r; result.im:=i;
 end;

 function cabs(c:complex):double; begin cabs:=sqrt(sqr(c.re)+sqr(c.im)) end;

 function arg(b:complex):double; var r,i,fi,tgfi:double;
 begin r:=b.re; i:=b.im;
  if (r=0) and (i=0) then fi:=0; {uslovno}
  if (r=0) and (i>0) then fi:=pi/2;
  if (r=0) and (i<0) then fi:=3*pi/2;
  if (r<>0) then begin
   tgfi:=i/r; fi:=arctan(tgfi);
   if r<0 then fi:=fi+pi; if (i<0) and (r>0) then fi:=fi+2*pi
  end; {eto obyesp.fi=0..2*pi}; arg:=fi
 end;

 function cmplx(x,y:double):complex;
 with result do begin re:=x; im:=y; end;

 function eq_cc(a,b:complex):boolean;
 result:=(a.re=b.re) and (a.im=b.im);  
 overload = = eq_cc;

 function add_cc(a,b:complex):complex;
 with result do begin re:=a.re+b.re; im:=a.im+b.im; end;
 overload + = add_cc;
 function add_cr(a:complex; b:double):complex;
 with result do begin re:=a.re+b; im:=a.im; end;
 overload + = add_cr;
 function add_rc(a:double; b:complex):complex;
 with result do begin re:=a+b.re; im:=b.im; end;
 overload + = add_rc;

 function sub_cc(a,b:complex):complex;
 with result do begin re:=a.re-b.re; im:=a.im-b.im; end;
 overload - = sub_cc;
 function sub_cr(a:complex; b:double):complex;
 with result do begin re:=a.re-b; im:=a.im; end;
 overload - = sub_cr;
 function sub_rc(a:double; b:complex):complex;
 with result do begin re:=a-b.re; im:=-b.im; end;
 overload - = sub_rc;

 function mul_cc(a,b:complex):complex;
 with result do begin re:=a.re*b.re-a.im*b.im; im:=a.re*b.im+b.re*a.im; end;
 overload * = mul_cc;
 function mul_cr(a:complex; b:double):complex;
 with result do begin re:=a.re*b; im:=a.im*b; end;
 overload * = mul_cr;
 function mul_rc(a:double; b:complex):complex;
 with result do begin re:=a*b.re; im:=a*b.im; end;
 overload * = mul_rc;

 function csqr(b:complex):complex;
 begin csqr:=b*b; end;

 function div_cc(a,b:complex):complex; var d:double;
 with result do begin
 begin d:=sqr(b.re)+sqr(b.im);
  if d>0 then begin
   re:=(a.re*b.re+a.im*b.im)/d; im:=(a.im*b.re-a.re*b.im)/d
  end else begin
   re:=0; im:=0; {uslovno}
  end;
 end;
 end;
 overload / = div_cc;
 function div_cr(a:complex; b:double):complex;
 with result do begin re:=a.re/b; im:=a.im/b; end;
 overload / = div_cr;

 function cexp(b:complex):complex; var c:double;
 with result do begin c:=exp(b.re); re:=c*cos(b.im); im:=c*sin(b.im); end;
 {overload exp = cexp;}
 function ccos(b:complex):complex; const i:complex=(re:0; im:1);
 begin ccos:=0.5*(cexp(i*b)+cexp(-1*i*b)); end;
 {overload cos = ccos;}
 function csin(b:complex):complex; const i:complex=(re:0; im:1);
 begin csin:=-0.5*i*(cexp(i*b)-cexp(-1*i*b)); end;
 {overload sin = csin;}
 function c_tg(b:complex):complex;
 begin c_tg:=csin(b)/ccos(b); end;

 {--------------------}
